VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Crazy mouse!"
   ClientHeight    =   1320
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   3450
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1320
   ScaleWidth      =   3450
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "MOVE IT!"
      Height          =   855
      Left            =   315
      TabIndex        =   0
      Top             =   255
      Width           =   2880
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SetCursorPos Lib "user32" (ByVal x As Long, ByVal Y As Long) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As Point) As Long

Private Type Point
    x   As Long
    Y   As Long
End Type

Private WithEvents Animation As Easing
Attribute Animation.VB_VarHelpID = -1

Dim targetsLeft     As Long
Dim curTarget       As Long
Dim target()        As Point
Dim fncs(1 To 8)    As EasingType
'

Private Sub MoveCursorTo(pos As Point)
    
    Dim curPos          As Point
    Dim lStart(1 To 2)  As Single
    Dim lEnd(1 To 2)    As Single
    
    GetCursorPos curPos
    
    lStart(1) = curPos.x
    lStart(2) = curPos.Y
    
    lEnd(1) = pos.x
    lEnd(2) = pos.Y
    
    Animation.Start fncs(Random(1, 8)), lStart, lEnd, 4000
    
End Sub
'

Private Sub NextTarget()
    
    If targetsLeft > 0 Then
    
        targetsLeft = targetsLeft - 1
        
        curTarget = curTarget + 1
        
        MoveCursorTo target(curTarget)
    
    Else
        
        Command1.Enabled = True
    
    End If

End Sub
'

Private Sub MoveCursorByPolygon(ParamArray dots() As Variant)
    
    Dim i As Long
    
    targetsLeft = UBound(dots(0))
    ReDim target(0 To targetsLeft - 1)
    
    For i = 0 To targetsLeft - 1 Step 2
        target(i).x = dots(0)(i)
        target(i).Y = dots(0)(i + 1)
    Next
    
    curTarget = -1
    
    NextTarget

End Sub
'

Private Function Random(lMin As Long, lMax As Long) As Long
    Random = Int(Rnd * (lMax - lMin + 1)) + lMin
End Function
'

Private Sub Animation_onEnd(CurrentValue() As Single, Aborted As Boolean)
    NextTarget
End Sub
'

Private Sub Animation_onFrame(Value() As Single)
    SetCursorPos Value(1), Value(2)
    DoEvents
End Sub
'

Private Sub Command1_Click()
    
    Dim dots()  As Long
    Dim lCount  As Long
    Dim i       As Long
    Dim max     As Point
    
    Command1.Enabled = False
    
    max.x = Screen.Width / Screen.TwipsPerPixelX
    max.Y = Screen.Height / Screen.TwipsPerPixelY
    
    lCount = Random(1, 10)
    
    ReDim dots(0 To lCount * 2 - 1)
    
    For i = 0 To UBound(dots) Step 2
        dots(i) = Random(0, max.x)
        dots(i + 1) = Random(0, max.Y)
    Next
    
    MoveCursorByPolygon dots
    
End Sub
'

Private Sub Form_Load()
    
    Set Animation = New Easing
    
    fncs(1) = BackInOut
    fncs(2) = BounceIn
    fncs(3) = BounceInOut
    fncs(4) = Linear
    fncs(5) = EaseInOut
    fncs(6) = ElasIn
    fncs(7) = ElasInOut
    fncs(8) = ElasOut
    
    Randomize Timer

End Sub
